# [Engula](https://engula.io)

[![Zulip][zulip-badge]][zulip-url]
[![Twitter][twitter-badge]][twitter-url]

[zulip-badge]: https://img.shields.io/badge/Zulip-chat-brightgreen?style=flat-square&logo=zulip
[zulip-url]: https://engula.zulipchat.com
[twitter-badge]: https://img.shields.io/twitter/follow/engulaio?style=flat-square&logo=twitter&color=brightgreen
[twitter-url]: https://twitter.com/intent/follow?screen_name=engulaio

Engula is a serverless storage engine that empowers engineers to build reliable and cost-effective databases.

Engula's design goals are as follows:

- **Elastic**: takes advantage of elastic resources on the cloud
- **Adaptive**: adapts to dynamic workloads and diverse applications
- **Extensible**: provides pluggable APIs and modules for customization
- **Platform independent**: allows flexible deployments on local hosts, on-premise servers, and cloud platforms

## Status

We are working on version 0.2. Please check the [roadmap][roadmap] for more details.

[roadmap]: https://github.com/engula/engula/issues/57

We have released Demo 1 in Oct 2021.
You can check [the branch](https://github.com/engula/engula/tree/demo-1) and [the report](https://engula.com/posts/demo-1/) for more details.

## Design

![Architecture](docs/images/architecture.drawio.svg)

For internal designs of Engula, please see the [docs](docs).

## Discussion

For discussions about ideas, designs, and roadmaps, please see the [discussions](https://github.com/engula/engula/discussions).

## Contributing

Thanks for your help improving the project! We have a [contributing guide](CONTRIBUTING.md) to help you get involved in the Engula project.
